"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Dict = void 0;
var Dict = /** @class */ (function () {
    function Dict() {
        this.data = {};
    }
    Dict.prototype.get = function (key) {
        return key === void 0 || key === null ? void 0 : this.data[key.toString()];
    };
    Dict.prototype.clear = function () {
        return this.data = {};
    };
    Dict.prototype.set = function (key, value) {
        if (key === void 0 || key === null) {
            return;
        }
        this.data[key.toString()] = value;
    };
    Dict.prototype.has = function (key) {
        return key !== void 0 && key !== null && this.data[key.toString()] !== void 0;
    };
    Dict.prototype.delete = function (key) {
        if (key === void 0 || key === null) {
            return;
        }
        delete this.data[key.toString()];
    };
    Dict.prototype.keys = function () {
        return Object.keys(this.data);
    };
    Dict.prototype.size = function () {
        return Object.keys(this.data).length;
    };
    Dict.prototype.values = function () {
        var _this = this;
        return this.keys().map(function (key) { return _this.data[key]; });
    };
    return Dict;
}());
exports.Dict = Dict;
//# sourceMappingURL=Dict.js.map