"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DummyRouterConnector = void 0;
var Dict_1 = require("../polyfill/Dict");
var DummyRouterConnector = /** @class */ (function () {
    function DummyRouterConnector() {
        this.subscriptions = new Dict_1.Dict();
        DummyRouterConnector.instances.push(this);
    }
    DummyRouterConnector.prototype.send = function (key, data) {
        for (var _i = 0, _a = DummyRouterConnector.instances; _i < _a.length; _i++) {
            var connector = _a[_i];
            if (connector !== this && connector.onMessage && connector.onMessage(key, data)) {
                return;
            }
        }
    };
    DummyRouterConnector.prototype.requestReadyState = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve) {
                        var _loop_1 = function (connector) {
                            if (connector !== _this && connector.onRequestReadyState && connector.onRequestReadyState(key)) {
                                setTimeout(function () { return resolve(connector.onRequestReadyState(key)); }, 0);
                                return { value: void 0 };
                            }
                        };
                        for (var _i = 0, _a = DummyRouterConnector.instances; _i < _a.length; _i++) {
                            var connector = _a[_i];
                            var state_1 = _loop_1(connector);
                            if (typeof state_1 === "object")
                                return state_1.value;
                        }
                    })];
            });
        });
    };
    DummyRouterConnector.prototype.emitMessage = function (key, event) {
        var _this = this;
        DummyRouterConnector.instances.forEach(function (connector) {
            if (connector !== _this) {
                (connector.subscriptions.get(key) || [])
                    .forEach(function (ws) { return setTimeout(function () { return ws.emitMessage(event); }); });
            }
        });
    };
    DummyRouterConnector.prototype.subscribe = function (key, ws) {
        if (!this.subscriptions.has(key)) {
            this.subscriptions.set(key, [ws]);
        }
        else {
            var subscriptions = this.subscriptions.get(key);
            var index = subscriptions.indexOf(ws);
            if (index === -1) {
                subscriptions.push(ws);
            }
        }
    };
    DummyRouterConnector.prototype.unsubscribe = function (key, ws) {
        var subscriptions = this.subscriptions.get(key) || [];
        var index = subscriptions.indexOf(ws);
        if (index >= 0) {
            subscriptions.splice(index, 1);
        }
    };
    DummyRouterConnector.prototype.broadcast = function (data) {
        var _this = this;
        DummyRouterConnector.instances.forEach(function (connector) {
            if (connector !== _this && connector.onBroadcast) {
                setTimeout(function () { return connector.onBroadcast(data); });
            }
        });
    };
    DummyRouterConnector.prototype.readyState = function (key, status) {
        var _this = this;
        DummyRouterConnector.instances.forEach(function (connector) {
            setTimeout(function () {
                if (connector !== _this && connector.onStatus) {
                    connector.onStatus(key, status);
                }
            });
        });
    };
    DummyRouterConnector.prototype.close = function (key, code, reason) {
        for (var _i = 0, _a = DummyRouterConnector.instances; _i < _a.length; _i++) {
            var connector = _a[_i];
            if (connector !== this && connector.onClose && connector.onClose(key, code, reason)) {
                return;
            }
        }
    };
    DummyRouterConnector.clear = function () { return DummyRouterConnector.instances.length = 0; };
    DummyRouterConnector.instances = [];
    return DummyRouterConnector;
}());
exports.DummyRouterConnector = DummyRouterConnector;
//# sourceMappingURL=DummyRouterConnector.js.map