import IHydratedWebSocketEventMap from "../IHydratedWebSocketEventMap";
import { Shell } from "../Shell";
export declare class RoutedWebSocket extends Shell {
    private readonly routerSend;
    private readonly routerClose;
    private readonly onMessageSubscribe?;
    private readonly onMessageUnsubscribe?;
    set onmessage(f: (ev: MessageEvent) => any);
    get onmessage(): (ev: MessageEvent) => any;
    get url(): string;
    get bufferedAmount(): number;
    get extensions(): string;
    get protocol(): string;
    /** The connection is not yet open. */
    readonly CONNECTING: number;
    /**  The connection is open and ready to communicate. */
    readonly OPEN: number;
    /**  The connection is in the process of closing. */
    readonly CLOSING: number;
    /**  The connection is closed or couldn't be opened. */
    readonly CLOSED: number;
    private virtualReadyState;
    private subscribed;
    constructor(routerSend: (data: string | ArrayBuffer | Blob | ArrayBufferView) => void, routerClose: (code: number, reason: string) => void, onMessageSubscribe?: (ws: RoutedWebSocket) => void, onMessageUnsubscribe?: (ws: RoutedWebSocket) => void);
    setReadyState(state: number): void;
    addEventListener<K extends keyof IHydratedWebSocketEventMap>(type: K, listener: (this: WebSocket, ev: IHydratedWebSocketEventMap[K]) => any, useCapture?: boolean): void;
    removeEventListener<K extends keyof IHydratedWebSocketEventMap>(type: K, listener: (this: WebSocket, ev: IHydratedWebSocketEventMap[K]) => any, useCapture?: boolean): void;
    emitMessage(event: MessageEvent): void;
    send(data: string | ArrayBuffer | Blob | ArrayBufferView): void;
    close(code?: number, reason?: string): void;
    protected getReadyState(): number;
    private checkSubscriptions;
}
