"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.RoutedWebSocket = void 0;
var CloseEvent_1 = require("../polyfill/CloseEvent");
var Event_1 = require("../polyfill/Event");
var WebSocket_1 = require("../polyfill/WebSocket");
var Shell_1 = require("../Shell");
var RoutedWebSocket = /** @class */ (function (_super) {
    __extends(RoutedWebSocket, _super);
    function RoutedWebSocket(routerSend, routerClose, onMessageSubscribe, onMessageUnsubscribe) {
        var _this = _super.call(this) || this;
        _this.routerSend = routerSend;
        _this.routerClose = routerClose;
        _this.onMessageSubscribe = onMessageSubscribe;
        _this.onMessageUnsubscribe = onMessageUnsubscribe;
        /** The connection is not yet open. */
        _this.CONNECTING = WebSocket_1.default.CONNECTING;
        /**  The connection is open and ready to communicate. */
        _this.OPEN = WebSocket_1.default.OPEN;
        /**  The connection is in the process of closing. */
        _this.CLOSING = WebSocket_1.default.CLOSING;
        /**  The connection is closed or couldn't be opened. */
        _this.CLOSED = WebSocket_1.default.CLOSED;
        _this.virtualReadyState = null;
        _this.subscribed = false;
        return _this;
    }
    Object.defineProperty(RoutedWebSocket.prototype, "onmessage", {
        get: function () {
            return _super.prototype.getOnmessage.call(this);
        },
        set: function (f) {
            _super.prototype.setOnmessage.call(this, f);
            this.checkSubscriptions();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RoutedWebSocket.prototype, "url", {
        get: function () {
            return "";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RoutedWebSocket.prototype, "bufferedAmount", {
        get: function () {
            return 0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RoutedWebSocket.prototype, "extensions", {
        get: function () {
            return "";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(RoutedWebSocket.prototype, "protocol", {
        get: function () {
            return "";
        },
        enumerable: false,
        configurable: true
    });
    RoutedWebSocket.prototype.setReadyState = function (state) {
        if (this.virtualReadyState === state) {
            return;
        }
        this.virtualReadyState = state;
        switch (state) {
            case this.OPEN:
                this.dispatchEvent(new Event_1.default("open"));
                break;
            case this.CLOSED:
                this.dispatchEvent(new CloseEvent_1.default("close"));
                break;
            default:
                break;
        }
    };
    RoutedWebSocket.prototype.addEventListener = function (type, listener, useCapture) {
        _super.prototype.addEventListener.call(this, type, listener, useCapture);
        this.checkSubscriptions();
    };
    RoutedWebSocket.prototype.removeEventListener = function (type, listener, useCapture) {
        _super.prototype.removeEventListener.call(this, type, listener, useCapture);
        this.checkSubscriptions();
    };
    RoutedWebSocket.prototype.emitMessage = function (event) {
        this.dispatchEvent(event);
    };
    RoutedWebSocket.prototype.send = function (data) {
        this.routerSend(data);
    };
    RoutedWebSocket.prototype.close = function (code, reason) {
        if (code === void 0) { code = 1000; }
        this.virtualReadyState = this.CLOSED;
        this.routerClose(code, reason);
    };
    RoutedWebSocket.prototype.getReadyState = function () {
        return this.virtualReadyState === null ? WebSocket_1.default.CONNECTING : this.virtualReadyState;
    };
    RoutedWebSocket.prototype.checkSubscriptions = function () {
        if (this.onmessage || (this.listeners.has("message") && this.listeners.get("message").length)) {
            if (!this.subscribed) {
                this.subscribed = true;
                if (this.onMessageSubscribe) {
                    this.onMessageSubscribe(this);
                }
            }
        }
        else {
            if (this.subscribed) {
                this.subscribed = false;
                if (this.onMessageUnsubscribe) {
                    this.onMessageUnsubscribe(this);
                }
            }
        }
    };
    return RoutedWebSocket;
}(Shell_1.Shell));
exports.RoutedWebSocket = RoutedWebSocket;
//# sourceMappingURL=RoutedWebSocket.js.map