"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Waterfall = exports.REGEXP_URL = void 0;
var computedFrom_1 = require("../computedFrom");
var CloseEvent_1 = require("../polyfill/CloseEvent");
var CustomEvent_1 = require("../polyfill/CustomEvent");
var WebSocket_1 = require("../polyfill/WebSocket");
var Shell_1 = require("../Shell");
var exponentialTruncatedBackoff_1 = require("./exponentialTruncatedBackoff");
// https://gist.github.com/hansifer/32bcba48c24621c2da78
/* tslint:disable-next-line */
exports.REGEXP_URL = /^wss?:(?:\/\/(?:(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD])*@)?(?:\[(?:(?:(?:[0-9a-f]{1,4}:){6}(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|::(?:[0-9a-f]{1,4}:){5}(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|(?:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){4}(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|(?:[0-9a-f]{1,4}:[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){3}(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|(?:(?:[0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:){2}(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|(?:(?:[0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|(?:(?:[0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::(?:[0-9a-f]{1,4}:[0-9a-f]{1,4}|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3})|(?:(?:[0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4}|(?:(?:[0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::)|v[0-9a-f]+[-a-z0-9\._~!\$&'\(\)\*\+,;=:]+)\]|(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])(?:\.(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])){3}|(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD])*)(?::[0-9]*)?(?:\/(?:(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD]))*)*|\/(?:(?:(?:(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD]))+)(?:\/(?:(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD]))*)*)?|(?:(?:(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD]))+)(?:\/(?:(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD]))*)*|(?!(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD])))(?:\?(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\/\?\xA0-\uD7FF\uE000-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E\uDB80-\uDBBE\uDBC0-\uDBFE][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F\uDBBF\uDBFF][\uDC00-\uDFFD])*)?(?:\#(?:%[0-9a-f][0-9a-f]|[-a-z0-9\._~!\$&'\(\)\*\+,;=:@\/\?\xA0-\uD7FF\uF900-\uFDCF\uFDF0-\uFFEF]|[\uD800-\uD83E\uD840-\uD87E\uD880-\uD8BE\uD8C0-\uD8FE\uD900-\uD93E\uD940-\uD97E\uD980-\uD9BE\uD9C0-\uD9FE\uDA00-\uDA3E\uDA40-\uDA7E\uDA80-\uDABE\uDAC0-\uDAFE\uDB00-\uDB3E\uDB44-\uDB7E][\uDC00-\uDFFF]|[\uD83F\uD87F\uD8BF\uD8FF\uD93F\uD97F\uD9BF\uD9FF\uDA3F\uDA7F\uDABF\uDAFF\uDB3F\uDB7F][\uDC00-\uDFFD])*)?$/i;
/**
 * The Waterfall provide a Websocket that will try to reconnect automatically according to the policy
 */
var Waterfall = /** @class */ (function (_super) {
    __extends(Waterfall, _super);
    /**
     *
     * @param {string | (attempt: number, ws: Waterfall) => string} url
     * @param {string | string[]} protocols
     * @param {IWaterfallOptions} options
     */
    function Waterfall(url, protocols, options) {
        var _this = _super.call(this) || this;
        _this.protocols = protocols;
        _this.options = options;
        _this.connectionTimeout = 5000;
        _this.emitClose = false;
        _this.retryPolicy = exponentialTruncatedBackoff_1.exponentialTruncatedBackoff();
        _this.attempts = -1;
        if (!url) {
            throw new TypeError("Invalid url");
        }
        _this.urlGenerator = url;
        if (options) {
            _this.connectionTimeout = options.connectionTimeout || _this.connectionTimeout;
            _this.emitClose = options.emitClose || _this.emitClose;
            _this.retryPolicy = options.retryPolicy || _this.retryPolicy;
        }
        _this.reconnect();
        return _this;
    }
    Object.defineProperty(Waterfall.prototype, "url", {
        /**
         * The URL as resolved by the constructor. This is always an absolute URL.
         */
        get: function () {
            return this._url;
        },
        /**
         * Change the url
         */
        set: function (value) {
            this.urlGenerator = value;
            if (this._url !== value) {
                this._url = value;
                if (this.ws) {
                    this.ws.close(1000);
                }
            }
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Reset the connection (close/open)
     */
    Waterfall.prototype.reset = function () {
        if (this.ws) {
            this.ws.close(1000);
        }
    };
    Object.defineProperty(Waterfall.prototype, "readyState", {
        /**
         * The current state of the connection; this is one of the Ready state constants. **Read only.**
         */
        get: function () {
            return this._readyState;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Waterfall.prototype, "bufferedAmount", {
        /**
         * The number of bytes of data that have been queued using calls to _send()_ but not yet transmitted to the network.
         * This value resets to zero once all queued data has been sent. This value does not reset to zero when the
         * connection is closed; if you keep calling _send()_, this will continue to climb. **Read only**
         */
        get: function () {
            return this.ws.bufferedAmount;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Waterfall.prototype, "extensions", {
        /**
         * The extensions selected by the server. This is currently only the empty string or a list
         * of extensions as negotiated by the connection.
         */
        get: function () {
            // https://github.com/websockets/ws/issues/1244
            return typeof (this.ws.extensions) === "string" ? this.ws.extensions : "";
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Waterfall.prototype, "protocol", {
        get: function () {
            return this.ws.protocol;
        },
        enumerable: false,
        configurable: true
    });
    /**
     * Closes the WebSocket connection or connection attempt, if any.
     * If the connection is already CLOSED, this method does nothing.
     * @param {number} A numeric value indicating the status code explaining why the connection is being closed.
     * If this parameter is not specified, a default value of 1005 is assumed.
     * See the list of status codes https://developer.mozilla.org/en-US/docs/Web/API/CloseEvent#Status_codes
     * on the CloseEvent page for permitted values.
     * @param {string} A human-readable string explaining why the connection is closing.
     * This string must be no longer than 123 bytes of UTF-8 text (not characters).
     */
    Waterfall.prototype.close = function (code, reason) {
        if (code === void 0) { code = 1000; }
        if (this.closing) {
            return;
        }
        this.closing = true;
        clearTimeout(this.timeout);
        if (this.ws) {
            this.ws.close(code, reason);
        }
    };
    Object.defineProperty(Waterfall.prototype, "urlGenerator", {
        set: function (value) {
            if (typeof value === "string") {
                if (!value.match(exports.REGEXP_URL)) {
                    throw new TypeError("Invalid url");
                }
                this._urlGenerator = function () { return value; };
            }
            else {
                this._urlGenerator = value;
            }
        },
        enumerable: false,
        configurable: true
    });
    Waterfall.prototype.webSocketFactory = function () {
        return this.options && this.options.factory
            ? this.options.factory(this.url, this.protocols || [])
            : new WebSocket_1.default(this.url, this.protocols || []);
    };
    Waterfall.prototype.onOpenWebSocket = function (evt) {
        this.attempts = -1;
        clearTimeout(this.timeout);
        this._readyState = WebSocket_1.default.OPEN;
        this.dispatchEvent(evt);
    };
    Waterfall.prototype.reconnect = function (timeout) {
        var _this = this;
        this._readyState = WebSocket_1.default.CONNECTING;
        this.dispatchEvent(new CustomEvent_1.default("connecting", { detail: timeout }));
        if (timeout !== void 0) {
            setTimeout(function () { return _this.open(); }, timeout);
        }
        else {
            this.open();
        }
    };
    Waterfall.prototype.onCloseWebSocket = function (evt) {
        clearTimeout(this.timeout);
        if (this.closing) {
            this._readyState = WebSocket_1.default.CLOSED;
            this.dispatchEvent(evt);
            return;
        }
        var timeout = this.retryPolicy(this.attempts + 1, this);
        if (timeout === null) {
            this._readyState = WebSocket_1.default.CLOSED;
            this.dispatchEvent(evt);
        }
        else if (this.emitClose) {
            this._readyState = WebSocket_1.default.CLOSED;
            this.dispatchEvent(evt);
            this.reconnect(timeout);
        }
        else {
            this.reconnect(timeout);
        }
    };
    Waterfall.prototype.unbindWebSocket = function () {
        if (this.ws) {
            this.ws.onopen = null;
            this.ws.onclose = null;
            this.ws.onmessage = null;
            this.ws.onerror = null;
        }
    };
    Waterfall.prototype.bindWebSocket = function () {
        this.ws.onopen = this.onOpenWebSocket.bind(this);
        this.ws.onclose = this.onCloseWebSocket.bind(this);
        this.ws.onmessage = this.dispatchEvent.bind(this);
        this.ws.onerror = this.dispatchEvent.bind(this);
    };
    Waterfall.prototype.forceClose = function (silent) {
        if (silent === void 0) { silent = false; }
        try {
            if (silent) {
                this.unbindWebSocket();
            }
            this.ws.close();
        }
        catch (_a) {
            // ignore
        }
    };
    Waterfall.prototype.failed = function () {
        var _this = this;
        clearTimeout(this.timeout);
        this.forceClose(true);
        var timeout = this.retryPolicy(this.attempts + 1, this);
        if (timeout === null) {
            this._readyState = WebSocket_1.default.CLOSED;
            this.dispatchEvent(new CloseEvent_1.default("close", { code: 4000, reason: "Connect timeout" }));
        }
        else {
            setTimeout(function () { return _this.open(); }, timeout);
        }
    };
    Waterfall.prototype.setupWebSocketTimeout = function () {
        var _this = this;
        clearTimeout(this.timeout);
        this.timeout = setTimeout(function () {
            _this.failed();
        }, this.connectionTimeout);
    };
    Waterfall.prototype.open = function () {
        var _this = this;
        if (this.closing) {
            return;
        }
        var doOpen = function (url) {
            _this._url = url;
            _this.forceClose(true);
            try {
                _this.ws = _this.webSocketFactory();
                _this.ws.binaryType = _this.binaryType || _this.ws.binaryType;
                _this.setupWebSocketTimeout();
                _this.bindWebSocket();
            }
            catch (e) {
                _this.failed();
            }
        };
        this.attempts++;
        var urlOrPromise = this._urlGenerator(this.attempts, this);
        urlOrPromise.then ? urlOrPromise.then(doOpen).catch(function () { return _this.failed(); }) : doOpen(urlOrPromise);
    };
    __decorate([
        computedFrom_1.computedFrom("_url")
    ], Waterfall.prototype, "url", null);
    __decorate([
        computedFrom_1.computedFrom("_readyState")
    ], Waterfall.prototype, "readyState", null);
    __decorate([
        computedFrom_1.computedFrom("ws.bufferedAmount")
    ], Waterfall.prototype, "bufferedAmount", null);
    __decorate([
        computedFrom_1.computedFrom("ws.extensions")
    ], Waterfall.prototype, "extensions", null);
    __decorate([
        computedFrom_1.computedFrom("ws.protocol")
    ], Waterfall.prototype, "protocol", null);
    return Waterfall;
}(Shell_1.Shell));
exports.Waterfall = Waterfall;
//# sourceMappingURL=Waterfall.js.map